import { ModelInstance, Relation, BaseProps } from "./index";
export declare class Model<P, M extends ModelInstance<P>> {
    label: String;
    relations: Relation[];
    modelInstanceClass: new (props: P) => M;
    protected beforeCreate(props: P): P;
    protected afterCreate(instance: M): M;
    protected beforeFind(props?: P & BaseProps): (P & BaseProps) | null;
    protected afterFind(instance: M): M;
    protected beforeUpdate(props: P & BaseProps, newProps: P): {
        props: P & BaseProps;
        newProps: P;
    };
    protected afterUpdate(instance: M): M;
    protected _createModelInstance(props: P & BaseProps): M;
    constructor(label: string);
    create(props: P): Promise<M>;
    findByGuid(guid: string): Promise<M | null>;
    delete(props: P & BaseProps, detach?: boolean): Promise<number>;
    find(props?: P & BaseProps): Promise<M[]>;
    findOne(props?: P & BaseProps): Promise<M | null>;
    update(props: P & BaseProps, newProps: P): Promise<M[]>;
}
