import { Model, ModelInstance } from "./index";
import { relationProperty, lazyModel } from "./Decorators";
export declare type RelationType = {
    many: boolean;
    out?: boolean;
    any?: boolean;
};
export declare class Relation {
    relationType: RelationType;
    src: Model<any, any>;
    dest: lazyModel<any, any>;
    propertyName: string;
    label: string;
    lazy: relationProperty;
    constructor(src: Model<any, any>, property: relationProperty);
    /**
     * Initialise all lazy stuff
     */
    init(): void;
    addFunctionsToInstance<P, M extends ModelInstance<P>>(instance: M): M;
    addHasManyToInstance<P, M extends ModelInstance<P>>(instance: M): any;
    addHasOneToInstance<P, M extends ModelInstance<P>>(instance: M): any;
}
