"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Relation_1 = require("../Relation");
const index_1 = require("./index");
class ConnectHelper {
    constructor() {
        this.models = [];
    }
    tryInject() {
        const buf = [];
        this.models.forEach(m => {
            const model = index_1.lazy(m.model);
            if (model) {
                model.modelInstanceClass = m.modelInstance;
                if (m.relations) {
                    model.relations = m.relations.map(r => new Relation_1.Relation(model, r));
                }
            }
            else {
                buf.push(m);
            }
        });
        this.models = buf;
    }
}
exports.ConnectHelper = ConnectHelper;
exports.connectHelper = new ConnectHelper();
